//
//	File:			Brain.java
//	Author:		Krzysztof Langner
//	Date:			1997/04/28
//

//  Modified by:  Paul Marlow, Amir Ghavam, Yoga Selvaraj
//  Course:       Software Agents
//  Date Due:     November 30, 2000

//  Modified by:  Tarek Hassan
//  Date:         03 July 2001

//  Modified by:  Paul Marlow - January 2002

import java.lang.Math;
import java.util.StringTokenizer;
import java.io.*;
import java.util.*; 
import java.awt.*;

class Brain extends Thread implements SensorInput
{
  public SendCommand m_IAS;  // robot which is controled by this brain
  public Memory m_memory;    // place where all information is stored
  public char m_side;
  public boolean m_hasMoved = false;
  public boolean m_resetPosition = false;
  volatile protected boolean m_timeOver;
  private PlayerCanvas p_canvas;

  //---------------------------------------------------------------------------
  // This constructor:
  // - stores connection to IAS
  // - starts thread for this object
  public Brain(SendCommand IAS, String team, char side, int number,
          String playMode)
  {
    m_timeOver = false;
    m_IAS = IAS;
    m_memory = new Memory();
    m_side = side;
    //m_team = team;
    //m_number = number;
    //m_playMode = playMode;
    start();
  }

  //---------------------------------------------------------------------------
  // This is main brain function used to fetch and process the user's instructions
  public void run()
  {
    ObjectInfo object = null;

    resetPlayerPosition();
    // first put it somewhere on my side
    // m_IAS.move( -Math.random()*52.5 , Math.random()*34.0 );        

    while( !m_timeOver )
    {
      m_IAS.sensebody();          // sends 'sense_body' to server (won't need this once using v5.x+
      m_IAS.nextCommand();        // gets the users next instruction and performs it
      try{
        Thread.sleep(2*SoccerParams.simulator_step);
      }catch(Exception e){}
    }
  }

  //===========================================================================
  // Implementation of SensorInput Interface

  //---------------------------------------------------------------------------
  // This function sends see information
  public void see(VisualInfo info)
  {
    m_memory.store(info);
  }

  //---------------------------------------------------------------------------
  // This function sends sense body information
  public void sense(SenseBodyInfo info)
  {
    m_memory.store(info);
  }

  //---------------------------------------------------------------------------
  // This function receives hear information from player
  public void hear(int time, int direction, String message)
  {
    // Needs implementation
  }

  //---------------------------------------------------------------------------
  // This function receives hear information from referee
  public void hear(int time, String message)
  {
    String m = new String(message + '\n');
    // Takes into account any message from the referee pertaining to a stop
    // in the game play
    if (message.startsWith("kick") ||
        message.startsWith("corner_kick") ||
        message.startsWith("offside") ||
        message.startsWith("goal") ||
        message.startsWith("foul") ||
        message.startsWith("free_kick") ||
        message.startsWith("time_up") ||
        message.startsWith("extend") ||
        message.startsWith("half_time"))
    {
      resetPlayerPosition();
    }
  }

  public void resetPlayerPosition()
  {
    // Don't really care where regular players get positioned
  }
}
