 
//	File:			Log.java
//	Author:		Tarek Hassan
//	Date:			06 July 2001

// 	Modified by:  Paul Marlow - January 2002

import java.util.*;  
import java.io.*;

public class Log {

  private FileOutputStream output;
  private int time = 0;

  public Log()
  {  
    try
    {
      output = new FileOutputStream("log.txt", false);
    }
    catch (FileNotFoundException e)
    {
      System.out.println("Error, file not found");
    }
  }

  // Sets the current time value
  public void setTime(float t)
  {
  time = (int) t;
  }

  // puts visual data in log
  public void visualData(ObjectInfo obj)
  {
    try {
      // format: (see TIME DISTANCE DIRECTION DISTCHNG DIRCHNG BodyDir HeadDir)
      String out = " (see " + time + " " + obj.m_type + " " + obj.m_distance
      + " " + obj.m_direction + " " + obj.m_distChange + " " + obj.m_dirChange + " BodyDir HeadDir) ";
      output.write(out.getBytes());
      output.flush();
      //System.out.println("Visual data logged.");
    }
    catch (IOException e)
    {
        System.out.println("Error writing to file!");
    }
  }

  // puts a simple(dash/turn/kick) action in log
  public void simpleAction(Command action)
  {  // format: (ACTION PARAMETER(s), @time TIME)
    String out;
    if (action.getVar2() == -999){ //no second variable
      out = " (" + action.getType() + " " + action.getVar1()
      + ", @time " + time + ") ";
    } else {
      out = " (" + action.getType() + " " + action.getVar1()
      + " " + action.getVar2() + ", @time " + time + ") ";
    }
    
    try {
      output.write(out.getBytes());
      output.flush();
      //System.out.println("Simple action logged.");
    }
    catch (IOException e)
    {
        System.out.println("Error writing to file!");
    }
  }

  /* To be implemented...

  public void audioData(....)
  {
  }

  public void complexAction(....)
  {
  }

  public void situation(....)
  {
  }

  */
}