
//	File:			PlayerFrame.java
//	Author:		Tarek Hassan
//	Date:			10 July 2001
//

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.SwingConstants;
import javax.swing.border.*;

public class PlayerFrame extends JFrame {
  private int maxStamina = 2000;
  private int minStamina = 0;
  private String time = "0";
  BorderLayout b_layout = new BorderLayout();
  JMenuBar menuBar = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  //JMenu menuHelp = new JMenu();
  //JMenuItem menuHelpAbout = new JMenuItem();
  JToolBar toolBar = new JToolBar(JToolBar.VERTICAL);
  JLabel statusBar = new JLabel();
  public PlayerCanvas p_canvas;
  JPanel statusPanel = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JProgressBar stamina;
  JPanel StaminaPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel StaminaLabel = new JLabel();   
  JLabel timeDisplay = new JLabel();
  Border border1;
  Border border2;
  JMenuItem Help = new JMenuItem();

  BorderLayout borderLayout3 = new BorderLayout();
  JPanel gamePanel = new JPanel();
  JLabel gameMode = new JLabel();

  //Construct the frame
  public PlayerFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    p_canvas = new PlayerCanvas();
    time = "0";
    this.addKeyListener(p_canvas.control);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new java.awt.Color(148, 145, 140));
    border2 = BorderFactory.createLineBorder(SystemColor.menu,2);
    this.getContentPane().setLayout(b_layout);
    this.setSize(new Dimension(650, 600));
    this.setTitle("IAS (In the Agent's Shoes) - RoboCup human player interface");
    statusBar.setFont(new java.awt.Font("Dialog", 0, 14));
    statusBar.setMinimumSize(new Dimension(100, 17));
    statusBar.setToolTipText("Shows last action performed");
    statusBar.setText("....");
    statusBar.setVerticalAlignment(SwingConstants.BOTTOM);
    statusBar.setVerticalTextPosition(SwingConstants.BOTTOM);
    stamina = new JProgressBar(minStamina, maxStamina);
    stamina.setValue(maxStamina);
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });

    Insets margin = new Insets(8, 8, 8, 8);
    toolBar.setMargin(margin);
    statusPanel.setLayout(borderLayout1);
    StaminaPanel.setLayout(borderLayout2);
    StaminaLabel.setFont(new java.awt.Font("Dialog", 0, 14));
    StaminaLabel.setText("Stamina  ");
    StaminaLabel.setVerticalAlignment(SwingConstants.BOTTOM);
    StaminaLabel.setVerticalTextPosition(SwingConstants.BOTTOM);
    stamina.setBackground(Color.gray);
    stamina.setForeground(Color.green);
    stamina.setBorder(BorderFactory.createLineBorder(Color.black));
    stamina.setMaximumSize(new Dimension(144, 14));
    stamina.setMinimumSize(new Dimension(144, 14));
    stamina.setSize(new Dimension(20, 14));
    stamina.setOpaque(true);
    stamina.setPreferredSize(new Dimension(144, 14));
    stamina.setToolTipText("Shows how much stamina you have left.");
    statusPanel.setBorder(border2);
    StaminaPanel.setBorder(border2);
    Help.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    Help.setText("Help");
    Help.setActionCommand("Help");
    timeDisplay.setFont(new java.awt.Font("Dialog", 0, 14));
    timeDisplay.setMaximumSize(new Dimension(30, 17));
    timeDisplay.setMinimumSize(new Dimension(30, 17));
    timeDisplay.setPreferredSize(new Dimension(30, 17));
    timeDisplay.setHorizontalAlignment(SwingConstants.CENTER);
    timeDisplay.setHorizontalTextPosition(SwingConstants.CENTER);
    timeDisplay.setToolTipText("Shows current game time");
    timeDisplay.setText(time);
    timeDisplay.setVerticalAlignment(SwingConstants.BOTTOM);
    timeDisplay.setVerticalTextPosition(SwingConstants.BOTTOM);
    //menuFile.add(Help);
    menuFile.add(menuFileExit);
    //menuHelp.add(menuHelpAbout);
    menuBar.add(menuFile);
    //menuBar.add(menuHelp);
    //p_canvas = new PlayerCanvas();
    //p_canvas.setBounds(0, 0, 300, 300);

    gamePanel.setLayout(borderLayout3);
    gameMode.setFont(new java.awt.Font("Dialog", 0, 14));
    gameMode.setMaximumSize(new Dimension(50, 17));
    gameMode.setMinimumSize(new Dimension(50, 17));
    gameMode.setPreferredSize(new Dimension(50, 17));
    gameMode.setHorizontalAlignment(SwingConstants.CENTER);
    gameMode.setHorizontalTextPosition(SwingConstants.CENTER);
    gameMode.setToolTipText("Current Game Mode");
    gameMode.setText("before_kick_off");
    gameMode.setVerticalAlignment(SwingConstants.BOTTOM);
    gameMode.setVerticalTextPosition(SwingConstants.BOTTOM);
    gamePanel.setBorder(border2);

    this.setJMenuBar(menuBar);
    this.getContentPane().add(toolBar, BorderLayout.EAST);
    this.getContentPane().add(p_canvas, BorderLayout.CENTER);
    this.getContentPane().add(statusPanel, BorderLayout.SOUTH);
    this.getContentPane().add(gamePanel, BorderLayout.NORTH);
    statusPanel.add(statusBar, BorderLayout.WEST);
    statusPanel.add(StaminaPanel, BorderLayout.EAST);
    StaminaPanel.add(stamina, BorderLayout.EAST);
    StaminaPanel.add(StaminaLabel, BorderLayout.WEST);
    statusPanel.add(timeDisplay, BorderLayout.CENTER);
    gamePanel.add(gameMode, BorderLayout.CENTER);
    //this.getContentPane().add(p_canvas);
    //this.getContentPane().add(toolBar);
    p_canvas.repaint();
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    //PlayerFrame_AboutBox dlg = new PlayerFrame_AboutBox(this);
    //Dimension dlgSize = dlg.getPreferredSize();
    //Dimension frmSize = getSize();
    //Point loc = getLocation();
    //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    //dlg.setModal(true);
    //dlg.show();
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  // updates the text in the status bar to show current action(s)
  public void setStatusBar(String status) {
    statusBar.setText(status);
  }

  // updates stamina display with current stamina (also turns orange when low and red when critical)
  public void setStamina(double st) {
    int value = (int)st;
    stamina.setValue(value);
    if (value < (maxStamina/5)){
      stamina.setForeground(Color.red);
    } else if (value < (maxStamina/3)){
        stamina.setForeground(Color.orange);
    } else {
      stamina.setForeground(Color.green);
    }
  }

  public void setTime(float t){
    Integer x = new Integer((int)t);
    time = x.toString();
    timeDisplay.setText(time);
  }

  void Help_actionPerformed(ActionEvent e) {

  }

}

